# Conditional build:
%bcond_without	kernel		# don't build kernel modules
%bcond_with	verbose		# verbose build (V=1)
%bcond_without	userspace	# don't build userspace programs
%bcond_without	dkms		# build dkms package

%if 0%{?_pld_builder:1} && %{with kernel} && %{with userspace}
%{error:kernel and userspace cannot be built at the same time on PLD builders}
exit 1
%endif

%if %{without userspace}
%undefine	with_dkms
%endif

# nothing to be placed to debuginfo package
%define		_enable_debug_packages	0

%define		_duplicate_files_terminate_build	0

%define		rel	7
%define		pname	wl
%define		file_ver	%(echo %{version} | tr . _)
Summary:	Broadcom 802.11 a/b/g/n hybrid Linux networking device driver
Name:		%{pname}%{?_pld_builder:%{?with_kernel:-kernel}}%{_alt_kernel}
Version:	6.30.223.271
Release:	%{rel}%{?_pld_builder:%{?with_kernel:@%{_kernel_ver_str}}}
License:	other
Group:		Base/Kernel
Source0:	http://www.broadcom.com/docs/linux_sta/hybrid-v35-nodebug-pcoem-%{file_ver}.tar.gz
# Source0-md5:	4e75f4cb7d87f690f9659ffc478495f0
Source1:	http://www.broadcom.com/docs/linux_sta/hybrid-v35_64-nodebug-pcoem-%{file_ver}.tar.gz
# Source1-md5:	115903050c41d466161784d4c843f4f9
Source2:	http://www.broadcom.com/docs/linux_sta/README.txt
# Source2-md5:	8a6e8708a5e00ab6d841cde51d70eb1b
Source3:	dkms.conf
Source4:	modprobe.conf
Patch0:		13-broadcom-sta-6.30.223.248-linux-3.18-null-pointer-crash.patch
Patch1:		gcc-4.9.patch
Patch2:		no-dead-code.patch
Patch3:		linux-4.7.patch
Patch4:		linux-4.8.patch
Patch5:		17-fix-kernel-warnings.patch
Patch6:		linux-4.11.patch
Patch7:		linux-4.12.patch
URL:		http://www.broadcom.com/support/802.11
BuildRequires:	rpmbuild(macros) >= 1.701
%{?with_kernel:%{expand:%buildrequires_kernel kernel%%{_alt_kernel}-module-build >= 3:2.6.20.2}}
ExclusiveArch:	%{ix86} %{x8664} x32
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
These packages contain Broadcom's IEEE 802.11a/b/g/n hybrid Linux
device driver for use with Broadcom's BCM4311-, BCM4312-, BCM4313-,
BCM4321-, BCM4322-, BCM43224-, and BCM43225-, BCM43227- and
BCM43228-based hardware.

This is an Official Release of Broadcom's hybrid Linux driver for use
with Broadcom based hardware.

%package -n dkms-%{pname}
Summary:	DKMS-ready driver for Broadcom WL driver
Group:		Base/Kernel
Release:	%{rel}
Requires(pre):	dkms
Requires(post):	dkms
%if "%{_rpmversion}" >= "5"
BuildArch:	noarch
%endif

%description -n dkms-%{pname}
This package contains a DKMS-ready driver for Broadcom WL driver.

%define	kernel_pkg()\
%package -n kernel%{_alt_kernel}-net-wl\
Summary:	Broadcom 802.11 a/b/g/n hybrid Linux networking device driver\
Release:	%{rel}@%{_kernel_ver_str}\
Group:		Base/Kernel\
Requires(post,postun):	/sbin/depmod\
%requires_releq_kernel\
Requires(postun):	%releq_kernel\
\
%description -n kernel%{_alt_kernel}-net-wl\
These packages contain Broadcom's IEEE 802.11a/b/g/n hybrid Linux\
device driver for use with Broadcom's BCM4311-, BCM4312-, BCM4313-,\
BCM4321-, BCM4322-, BCM43224-, and BCM43225-, BCM43227- and\
BCM43228-based hardware.\
\
This is an Official Release of Broadcom's hybrid Linux driver for use\
with Broadcom based hardware.\
\
%files -n kernel%{_alt_kernel}-net-wl\
%defattr(644,root,root,755)\
%doc wl/lib/LICENSE.txt README.txt\
/lib/modules/%{_kernel_ver}/kernel/drivers/net/wireless/*.ko*\
%config(noreplace) %verify(not md5 mtime size) /etc/modprobe.d/%{pname}.conf\
\
%post -n kernel%{_alt_kernel}-net-wl\
%depmod %{_kernel_ver}\
\
%posttrans -n kernel%{_alt_kernel}-net-wl\
%banner -e kernel%{_alt_kernel}-net-wl <<EOF\
WARNING! This kernel module is not GPL licensed.\
Before using it be sure to accept license: %{_docdir}/kernel%{_alt_kernel}-net-wl-%{version}/LICENSE.txt*\
EOF\
\
%postun -n kernel%{_alt_kernel}-net-wl\
%depmod %{_kernel_ver}\
%{nil}

%define build_kernel_pkg()\
%{__make} -C wl KERNELRELEASE=%{_kernel_ver} KBUILD_DIR=%{_kernelsrcdir} clean\
%{__make} -C wl KERNELRELEASE=%{_kernel_ver} KBUILD_DIR=%{_kernelsrcdir}\
%install_kernel_modules -D installed -m wl/wl -d kernel/drivers/net/wireless\
%{nil}

%{?with_kernel:%{expand:%create_kernel_packages}}

%prep
%ifarch %{x8664} x32
%define src 1
%else
%define src 0
%endif
%setup -c -T -q -n %{pname}-%{version} -b%{src}
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p2
%patch6 -p1
%patch7 -p1

mkdir wl
mv lib src Makefile wl/
cp -p %{SOURCE2} .

# cleanup backups after patching
find '(' -name '*~' -o -name '*.orig' ')' -print0 | xargs -0 -r -l512 rm -f

%build
%{?with_kernel:%{expand:%build_kernel_packages}}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT/etc/modprobe.d

%if %{with kernel}
install -d $RPM_BUILD_ROOT
cp -a installed/* $RPM_BUILD_ROOT
cp -p %{SOURCE4} $RPM_BUILD_ROOT/etc/modprobe.d/%{pname}.conf
%endif

%if %{with dkms}
install -d $RPM_BUILD_ROOT%{_usrsrc}/%{pname}-%{version}-%{rel}
cp -a wl/Makefile wl/lib wl/src $RPM_BUILD_ROOT%{_usrsrc}/%{pname}-%{version}-%{rel}
sed -e 's|@pname@|%{pname}|g' -e 's|@MODVERSION@|%{version}-%{rel}|g' \
	%{SOURCE3} > $RPM_BUILD_ROOT%{_usrsrc}/%{pname}-%{version}-%{rel}/dkms.conf
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post -n dkms-%{pname}
%{_sbindir}/dkms add -m %{pname} -v %{version}-%{rel} --rpm_safe_upgrade && \
%{_sbindir}/dkms build -m %{pname} -v %{version}-%{rel} --rpm_safe_upgrade && \
%{_sbindir}/dkms install -m %{pname} -v %{version}-%{rel} --rpm_safe_upgrade || :

%preun -n dkms-%{pname}
%{_sbindir}/dkms remove -m %{pname} -v %{version}-%{rel} --rpm_safe_upgrade --all || :

%if %{with dkms}
%files -n dkms-%{pname}
%defattr(644,root,root,755)
%{_usrsrc}/%{pname}-%{version}-%{rel}
%endif
%changelog
* Wed Jan 24 2018 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/wl.git;a=log;h=auto/th/wl-6.30.223.271-7

* Mon Jul 31 2017 Jan Rękorajski <baggins@pld-linux.org> 6030187
- rel 7
- fix building with kernel 4.12

* Tue May 09 2017 Jan Rękorajski <baggins@pld-linux.org> 94191af
- fix building with kerbel 4.11
- rel 6

* Thu Jan 19 2017 Jan Rękorajski <baggins@pld-linux.org> f316d7d
- * added 17-fix-kernel-warnings.patch from Debian (avoid useless kernel
  warnings and possibly add better tracibility of bogus auth failures)
- rel 5

* Tue Dec 27 2016 Jan Rękorajski <baggins@pld-linux.org> 18f1113
- rel 4

* Mon Nov 21 2016 Jan Rękorajski <baggins@pld-linux.org> f36814b
- updated URL

* Mon Oct 10 2016 Jan Rękorajski <baggins@pld-linux.org> 0e2168f
- added patches from Debian to fix old crash and new one on linux 4.8
- rel 3

* Sun Jul 31 2016 Jan Rękorajski <baggins@pld-linux.org> 5bfd004
- fix building with linux 4.7
- rel 2

* Thu Mar 17 2016 Jan Rękorajski <baggins@pld-linux.org> 726f0ca
- updated to 6.30.223.271
- don't use handcrafted Makefile, it produces useless shit
- add blacklist configuration for conflicting drivers

* Sat Dec 05 2015 Jan Rękorajski <baggins@pld-linux.org> c9fb484
- remove unused code that breaks build on i686 with linux 4.3
- rel 9

* Tue Mar 03 2015 Jan Rękorajski <baggins@pld-linux.org> 42a6a3d
- fix package naming
- rel 8

* Tue Mar 03 2015 Jan Rękorajski <baggins@pld-linux.org> b0a31fc
- use 64bit binary blob on x32
- rel 7

* Mon Mar 02 2015 Jan Rękorajski <baggins@pld-linux.org> 04b7561
- release 6 (by relup.sh)

* Mon Mar 02 2015 Jan Rękorajski <baggins@pld-linux.org> a613bf1
- that's binary driver, no version for x32

* Sun Mar 01 2015 Jan Rękorajski <baggins@pld-linux.org> 14b68eb
- x32 rebuild
- release 5 (by relup.sh)

* Sun Mar 01 2015 Jan Rękorajski <baggins@pld-linux.org> 493de62
- enable dkms for consistency

* Sun Mar 01 2015 Jan Rękorajski <baggins@pld-linux.org> c0eef97
- add x32 to the list of supported archs

* Sun Mar 01 2015 Jan Rękorajski <baggins@pld-linux.org> cd0280d
- wrap dkms in userspace bcond

* Tue Jan 27 2015 Jan Rękorajski <baggins@pld-linux.org> 747711c
- rel 4

* Tue Jan 27 2015 Jan Rękorajski <baggins@pld-linux.org> 87d5fa4
- updated kernel modules build system

* Tue Jan 27 2015 Jan Rękorajski <baggins@pld-linux.org> f989711
- drop non-dist kernl support

